#define DEBUG_TYPE "KernelInst"
#include "llvm/Transforms/IPO.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Instructions.h"
#include "llvm/Module.h"
#include "llvm/ADT/StringRef.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Pass.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/InstIterator.h"
#include <fstream>
#include <set>

#include "llvm/PassManager.h"

#include "llvm/Type.h"


#include "llvm/Analysis/LoopPass.h"


#include <list>

#include <cerrno>
#include <assert.h>
#include <iostream>
#include <sstream>
using namespace llvm;
using namespace std;

StringRef * timer_start= new StringRef ("timer_arnamoy_start");
StringRef * timer_end= new StringRef ("timer_arnamoy_end");
StringRef * print_kernels= new StringRef ("print_kernels_arnamoy");
StringRef * profile_int= new StringRef ("profile_int");
StringRef * profile_float= new StringRef ("profile_float");
StringRef * profile_long= new StringRef ("profile_long");
StringRef * profile_double= new StringRef ("profile_double");

StringRef * main= new StringRef ("main");
StringRef * loopCond= new StringRef ("for.cond");
StringRef * whileCond= new StringRef ("while.cond");
StringRef * loopInc= new StringRef ("for.inc");
StringRef * loopEnd= new StringRef ("for.end");
ValueToValueMapTy VMap;
ConstantInt* value_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
ConstantInt* value_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));

GlobalVariable* gvar_array__str;
GlobalVariable* gvar_ptr_s;
GlobalVariable* gvar_array__str_loop;
GlobalVariable* gvar_ptr_s_loop;
StoreInst* void_22;
LoadInst* ptr_23;

StoreInst* void_22_loop;
LoadInst* ptr_23_loop;

Constant *func_start;
Constant *func_end;

int loop_count;

namespace {
    struct KernelInst : public ModulePass {
        static char ID; // Pass identification, replacement for typeid
        unsigned NumLoops;
        KernelInst() : ModulePass(ID) {}
        
        virtual bool runOnModule(Module &M)
        {
			for(Module::iterator func = M.begin(), y = M.end(); func!= y; ++func)
        	{
                if (func->isDeclaration())
          			continue;
          		LoopInfo &LI = getAnalysis<LoopInfo>(* func);
          		
          		loop_count=0;
          		size_t size1=9999;
          		size_t size2=9999;
          		size_t size3=9999;
          		size_t size4=9999;
          		size_t size5=9999;
          		size_t size6=9999;
          		size_t size7=9999;
          		          		          		          		          		
                size1 = func->getName().find(*timer_start,0);
                size2 = func->getName().find(*timer_end,0);
                size3 = func->getName().find(*print_kernels,0);
                size4 = func->getName().find(*profile_int,0);
                size5 = func->getName().find(*profile_long,0);
                size6 = func->getName().find(*profile_float,0);
                size7 = func->getName().find(*profile_double,0);
                

                //don't profile our library functions
                if ((size1<200) || (size2<200)||(size3<200)
					||(size4<200) || (size5<200)||(size6<200)||	(size7<200))
                    continue;
                for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
	        	{

					if(F==func->begin())
					{
						//this is the first basic block of the function, so insert call inst
						for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) {
							if(j==F->begin())
							{
								//this is the first instruction of the function, insert a call to timer_start
                                 					//we have to ---
                    //1. create a global string with the function name
                    //2. call recompile with the function name
                                
                    //create a global string that has the function name as content
                    size_t size23 = func->getName().size();
                    //errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
                    ArrayType* ArrayTy_0 = ArrayType::get(IntegerType::getInt8Ty(getGlobalContext()), size23+1);
                    PointerType* PointerTy_2 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
                                    
                    gvar_array__str = new GlobalVariable(/*Module=*/M,
                                                                        /*Type=*/ArrayTy_0,
                                                                        /*isConstant=*/true,
                                                                        /*Linkage=*/GlobalValue::PrivateLinkage,
                                                                        /*Initializer=*/0, // has initializer, specified below
                                                                        /*Name=*/".str");
                                   
                    gvar_ptr_s = new GlobalVariable(/*Module=*/M,
                                                                    /*Type=*/PointerTy_2,
                                                                    /*isConstant=*/false,
                                                                    /*Linkage=*/GlobalValue::CommonLinkage,
                                                                    /*Initializer=*/0, // has initializer, specified below
                                                                    /*Name=*/"s");
                                    
                    Constant* const_array_12 = ConstantDataArray::getString(getGlobalContext(),func->getName() , true);
                    ConstantPointerNull* const_ptr_13 = ConstantPointerNull::get(PointerTy_2);
                                    
                    ConstantInt* const_int32_16 = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
                    std::vector<Constant*> const_ptr_17_indices;
                    const_ptr_17_indices.push_back(const_int32_16);
                    const_ptr_17_indices.push_back(const_int32_16);
                    Constant* const_ptr_17 = ConstantExpr::getGetElementPtr(gvar_array__str, const_ptr_17_indices);
                                    
                    gvar_array__str->setInitializer(const_array_12);
                    gvar_ptr_s->setInitializer(const_ptr_13);
                                    
                    //store the function name in the new pointer created
                    void_22 = new StoreInst(const_ptr_17, gvar_ptr_s, false);
                    //get the value of the pointer so that we can pass it as an argument to replacement()
                    ptr_23 = new LoadInst(gvar_ptr_s, "", false);
                                   

                                    
                    //now insert a call to timer_start()
                    PointerType* PointerTy_99 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);

                                    
                    func_start = M.getOrInsertFunction("timer_arnamoy_start", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
                    Function *func1;
                    CallInst* call_start;   
                                  if(func_start)
                                    {
                                        //errs()<<"Found timer_start()\n";
                                        func1= cast<Function>(func_start);
                                        call_start = CallInst::Create(func1, ptr_23, "");
                                        
                                        F->getInstList().insert((Instruction*)j, void_22);
                                        F->getInstList().insert((Instruction*)j, ptr_23);
                                        F->getInstList().insert((Instruction*)j, call_start);
                                    }
                            break;        
							} //end of if first inst of basic block
						    	
						}//end of  basic block iterator
					    break;	
					}//end of if first basic block of function
                }//end of function iterator
                
                //////now find the last instruction of the function and add call to timer_end()
                
               for (Function::iterator E1 = func->end(), F1 = func->begin();E1 != F1; ) {
					BasicBlock *BB = --E1;

						Instruction *inst = BB->getTerminator();
						//now "inst" is the last instruction of the function,insert a call to
						//timer_end()
						                   //1. create a global string with the function name
                    //2. call recompile with the function name
                                
                    //create a global string that has the function name as content
                    //size_t size23 = func->getName().size();
                    //errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
                    //now insert a call to recompile()
                    PointerType* PointerTy_99 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);

                                    
                    func_end = M.getOrInsertFunction("timer_arnamoy_end", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
                    Function *func1;
                    CallInst* call_start;   
                    if(func_end)
                    {
                      //errs()<<"Found timer_end()\n";
                      func1= cast<Function>(func_end);
                      call_start = CallInst::Create(func1, ptr_23, "");
                                        
                      BB->getInstList().insert(inst, call_start);
                    }
                    //also insert a call to print_kernels if the function is main
                    size_t size14=9999;
                    size14 = func->getName().find(*main,0);
                    if(size14<200)
                    {
						//errs()<<"Found main()\n";
						Constant *func_end1 = M.getOrInsertFunction("print_kernels_arnamoy", IntegerType::getInt32Ty
                                              (getGlobalContext()), NULL);
                         if(func_end1)
                         {
							//errs()<<"Found print_kernels\n";
							Function *func3=cast<Function>(func_end1);
							CallInst *call_print=CallInst::Create(func3, "");
							call_print->insertBefore(BB->getTerminator());
						}
					}
					break;
				}
               //Function * funcy = func;
               
               //////now find all the "call x" instructions and change them to
               //call timer_end()
               //call x
               //call timer_start()
				for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
	        	{
					//here a basic block may come that is part of a loop
					//don't deal with it as they are dealt separately later
					Loop *L = LI.getLoopFor(F);
					if(L) continue;
					for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) {

                    if (CallInst* callInst = dyn_cast<CallInst>(&*j)) {
								Function* fun3 = dyn_cast<Function>(callInst->
												getCalledValue()->stripPointerCasts());

												if (fun3 != NULL) {
						        		size_t size1=9999;
						size_t size2=9999;
						size1 = fun3->getName().find(*timer_start,0);
						size2 = fun3->getName().find(*timer_end,0);

                            
						if ((size1<200) || (size2<200))
							continue;

						//now insert a call to recompile()
						PointerType* PointerTy_99 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);

                                    
						func_start = M.getOrInsertFunction("timer_arnamoy_start", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
						func_end = M.getOrInsertFunction("timer_arnamoy_end", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
						Function *func1;

						CallInst* call_start;
						CallInst* call_end;   
                        if(func_end)
                        {
                          //errs()<<"Found timer_end()\n";
                          func1= cast<Function>(func_end);
                          call_end = CallInst::Create(func1, ptr_23, "");
                                        
                          call_end->insertBefore(callInst);
                        }  
						if(func_start)
                        {
                          //errs()<<"Found timer_start()\n";
                          func1= cast<Function>(func_start);
                          call_start = CallInst::Create(func1, ptr_23, "");
                          call_start->insertAfter(callInst);
                        } 
                       } 
                    }//end of if a call instruction
                } //end of while (I != inst_end(F))
			}
               
               ////dealing with loops
               for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
               {
					if ((!((F->getName().find(*loopCond,0)))) ||
					   (!((F->getName().find(*whileCond,0)))) )
					{
						Loop * L = LI.getLoopFor(F);
						if(L)
						{
							unsigned loop_depth = LI.getLoopDepth(F);
							
							//errs()<<loop_depth<<"\n";
							//only deal with top level loops
							if(loop_depth==1)
							{
								loop_count++;
						
								//create a name for the loop
								std::string count1;
								ostringstream convert; 
								convert << loop_count; 
								count1 = func->getName();
								count1.append("_");
								count1.append(convert.str());
						
								//and create a global variable with the string name
								size_t size23 = count1.size();
								//errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
								ArrayType* ArrayTy_0 = ArrayType::get(IntegerType::getInt8Ty(getGlobalContext()), size23+1);
								PointerType* PointerTy_2 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
                                    
								gvar_array__str_loop = new GlobalVariable(/*Module=*/M,
                                                                        /*Type=*/ArrayTy_0,
                                                                        /*isConstant=*/true,
                                                                        /*Linkage=*/GlobalValue::PrivateLinkage,
                                                                        /*Initializer=*/0, // has initializer, specified below
                                                                        /*Name=*/".str");
                                   
								gvar_ptr_s_loop = new GlobalVariable(/*Module=*/M,
                                                                    /*Type=*/PointerTy_2,
                                                                    /*isConstant=*/false,
                                                                    /*Linkage=*/GlobalValue::CommonLinkage,
                                                                    /*Initializer=*/0, // has initializer, specified below
                                                                    /*Name=*/"s");
                                    
								Constant* const_array_12 = ConstantDataArray::getString(getGlobalContext(),count1 , true);
								ConstantPointerNull* const_ptr_13 = ConstantPointerNull::get(PointerTy_2);
                                    
								ConstantInt* const_int32_16 = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
								std::vector<Constant*> const_ptr_17_indices;
								const_ptr_17_indices.push_back(const_int32_16);
								const_ptr_17_indices.push_back(const_int32_16);
								Constant* const_ptr_17 = ConstantExpr::getGetElementPtr(gvar_array__str_loop, const_ptr_17_indices);
                                    
								gvar_array__str_loop->setInitializer(const_array_12);
								gvar_ptr_s_loop->setInitializer(const_ptr_13);
                                    
								//store the loop name in the new pointer created
								void_22_loop = new StoreInst(const_ptr_17, gvar_ptr_s_loop, false);
								//get the value of the pointer so that we can pass it as an argument to replacement()
								ptr_23_loop = new LoadInst(gvar_ptr_s_loop, "", false);
    
								Function *func1;
								CallInst* call_start_loop;   

						
								//insert a call to timer_end(func) and timer_start(loop)
								//before the last instruction of the basic block
								//that is predecessor to for.cond
								//but for.cond normally have two predecessors
								//we ignore the loop back edge.
								BasicBlock* BB = dyn_cast<BasicBlock>(&*F);

								for (pred_iterator I = pred_begin(BB), E = pred_end(BB); I != E; ++I)  
								{   
									BasicBlock *Pred = *I;
									//normally there are two predecessors 
									//of the loop's first basic block
									//the one that comes from outside
									//the loop and the one comes from
									//inside of the loop. We want the one
									//outside the loop body here.
									/*if (!((Pred->getName().find(*loopInc,0))))
										continue;*/
									Loop * L1 = LI.getLoopFor(Pred);
									//as we are dealing with only top 
									//level loops, the predecessor to the
									//entry block should not be confined
									//in any loop
									if(L1)
										continue;
									else
									{
										//insert the call instructions
								
										if(func_start && func_end)
										{
											//errs()<<"Found timer_start()\n";
											func1= cast<Function>(func_start);
											Function *func2 = cast<Function>(func_end);
											call_start_loop = CallInst::Create(func1, ptr_23_loop, "");
											CallInst * call_end = CallInst::Create(func2, ptr_23, "");
                                        
											call_end->insertBefore(Pred->getTerminator());
											void_22_loop->insertBefore(Pred->getTerminator());
											ptr_23_loop->insertBefore(Pred->getTerminator());
                                        
											call_start_loop->insertBefore(Pred->getTerminator());
										}
								
									}
								}
								//now all is left
								//1. If there is a function call inside loop body, treat the same way
								//   as when there is a function call inside function body
								//2. End the loop timer and start the function timer at the end of the
								//   loop
								for(Loop::block_iterator BB = L->block_begin(), y = L->block_end(); 
								BB!= y; ++BB)
								{
									BasicBlock* block=*BB;
									
									//remember block iterator also returns basic blocks of inner level loops
									//thus we need a depth check here too
									unsigned depth = LI.getLoopDepth(block);
									if(depth==1)
									{
										for (BasicBlock::iterator j = block->begin(), e = block->end(); j != e; ++j ) {

											if (CallInst* callInst = dyn_cast<CallInst>(&*j)) {
												Function* fun2 = dyn_cast<Function>(callInst->
													getCalledValue()->stripPointerCasts());

												if (fun2 != NULL) {
												size_t size1=9999;
												size_t size2=9999;
												size1 = fun2->getName().find(*timer_start,0);
												size2 = fun2->getName().find(*timer_end,0);

                            
												if ((size1<200) || (size2<200))
													continue;

												//now insert a call to timer()
												PointerType* PointerTy_99 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);

                                    
												func_start = M.getOrInsertFunction("timer_arnamoy_start", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
												func_end = M.getOrInsertFunction("timer_arnamoy_end", IntegerType::getInt32Ty
                                                             (getGlobalContext()), PointerTy_99,NULL);
												Function *func1;

												CallInst* call_start;
												CallInst* call_end;   
												if(func_end)
												{
													//errs()<<"Found timer_end()\n";
													func1= cast<Function>(func_end);
													call_end = CallInst::Create(func1, ptr_23_loop, "");
                                        
													call_end->insertBefore(callInst);
												}  
												if(func_start)
												{
													//errs()<<"Found timer_start()\n";
													func1= cast<Function>(func_start);
													call_start = CallInst::Create(func1, ptr_23_loop, "");
													call_start->insertAfter(callInst);
												} 
												}
											}//end of if a call instruction
										} //end of for loop
									}//end of if(depth==1)
								}//end of loop block iterator
								//find the successor of loop's last block
								BasicBlock *last=L->getUniqueExitBlock();
								//errs()<<last->getName()<<"\n";
								//insert calls to loop_timer_end and function_timer_start 
								//before the first instruction of the exit block
								BasicBlock::iterator j = last->begin();
								func1= cast<Function>(func_end);
								CallInst * call = CallInst::Create(func1, ptr_23_loop, "");
								call->insertBefore(j);
								func1= cast<Function>(func_start);
								call = CallInst::Create(func1, ptr_23, "");
								call->insertBefore(j);
							}//end of if (loop_depth==1)
						} 

					}
				}
            }//end of Module iterator
            
            return true;
        }//end of runOnModule()
        
        virtual void getAnalysisUsage(AnalysisUsage &AU) const {
		AU.addRequired<LoopInfo>();
		AU.addPreserved<LoopInfo>();
            //AU.addRequiredID(BreakCriticalEdgesID);
            //AU.addRequiredID(LoopSimplifyID);
            //AU.addRequired<DominatorTree>();
        }
    };
}

char KernelInst::ID = 0;
static RegisterPass<KernelInst> X("kernel-inst", "KernelInst the supplied function",false);
