#define DEBUG_TYPE "LCGraph"
#include "llvm/Transforms/IPO.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Instructions.h"
#include "llvm/Module.h"
#include "llvm/ADT/StringRef.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Pass.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/InstIterator.h"
#include <fstream>
#include <set>
#include "llvm/DebugInfo.h"
#include "llvm/PassManager.h"

#include "llvm/Type.h"


#include "llvm/Analysis/LoopPass.h"


#include <list>

#include <cerrno>
#include <assert.h>
#include <iostream>
#include <sstream>
using namespace llvm;
using namespace std;

StringRef * timer_start= new StringRef ("timer_arnamoy_start");
StringRef * timer_end= new StringRef ("timer_arnamoy_end");
StringRef * print_kernels= new StringRef ("print_kernels_arnamoy");
StringRef * main= new StringRef ("main");
StringRef * loopCond= new StringRef ("for.cond");
StringRef * whileCond= new StringRef ("while.cond");
StringRef * loopInc= new StringRef ("for.inc");
StringRef * loopEnd= new StringRef ("for.end");
ValueToValueMapTy VMap;
ConstantInt* value_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
ConstantInt* value_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));

GlobalVariable* gvar_array__str;
GlobalVariable* gvar_ptr_s;
GlobalVariable* gvar_array__str_loop;
GlobalVariable* gvar_ptr_s_loop;
StoreInst* void_22;
LoadInst* ptr_23;

StoreInst* void_22_loop;
LoadInst* ptr_23_loop;

Constant *func_start;
Constant *func_end;

int loop_count;

namespace {
    struct LCGraph : public ModulePass {
        static char ID; // Pass identification, replacement for typeid
        unsigned NumLoops;
        LCGraph() : ModulePass(ID) {}
        
        virtual bool runOnModule(Module &M)
        {
			system(">lcg.dot");
			ofstream myfile;
			myfile.open ("temp.dot");

			for(Module::iterator func = M.begin(), y = M.end(); func!= y; ++func)
        	{
                if (func->isDeclaration())
          			continue;
          			          		loop_count=0;
          		size_t size1=9999;
          		size_t size2=9999;
          		size_t size3=9999;
                size1 = func->getName().find(*timer_start,0);
                size2 = func->getName().find(*timer_end,0);
                size3 = func->getName().find(*print_kernels,0);

                            
                if ((size1<200) || (size2<200)||(size3<200))
                    continue;
          		LoopInfo &LI = getAnalysis<LoopInfo>(* func);
				if(func->isIntrinsic())
					errs()<<"Intrinsic "<<func->getName()<<"\n";
					//give a label
				std::string value23;
				value23 = func->getName();												//create a label
				for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
               {
				   if(F==func->begin())
				   {
				  for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) { 	

							if (MDNode *N = j->getMetadata("dbg")) {  // Here I is an LLVM instruction
										DILocation Loc(N);                      // DILocation is in DebugInfo.h
									unsigned Line = Loc.getLineNumber();
									ostringstream convert1; 
									convert1 << Line; 
									StringRef File = Loc.getFilename();
									value23.append(" [label=\"");
									std::string vvv =func->getName();
									value23.append(vvv);
									value23.append(" ");
									value23.append(File);
									value23.append(" line: ");
									value23.append(convert1.str());
									value23.append(" \",");
									break;
								}						  

				  }
				  break;
			  }
			  }
			  								//give a shape
								value23.append(" color=\"brown\", shape=\"ellipse\", style=\"filled\"];");
								value23.append("\n");
								myfile<<value23;
					
				for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
	        	{
					//here a basic block may come that is part of a loop
					//don't deal with it as they are dealt separately later
					Loop *L = LI.getLoopFor(F);
					if(L) continue;
													
					for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) {

                    if (CallInst* callInst = dyn_cast<CallInst>(&*j)) {
								Function* fun3 = dyn_cast<Function>(callInst->
												getCalledValue()->stripPointerCasts());

												if (fun3 != NULL) {
						        		size_t size1=9999;
						size_t size2=9999;
						size1 = fun3->getName().find(*timer_start,0);
						size2 = fun3->getName().find(*timer_end,0);

                            
						if ((size1<200) || (size2<200))
							continue;
						if(fun3->isIntrinsic())
						{
							//errs()<<"Intrinsic "<<fun3->getName()<<"\n";
							continue;
						}
						if(fun3->empty())
						{
							//errs()<<"Empty library "<<fun3->getName()<<"\n";
							continue;
						}
								//giving the shapes

								
								
								
								std::string value22;
								value22 = func->getName();
								value22.append(" -> ");
								std::string name = fun3->getName();
								value22.append(name);
								value22.append(";\n");
						myfile<<value22;
                       } 
                    }//end of if a call instruction
                } //end of while (I != inst_end(F))
			}
			//dealing with loops
			 for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
               {
					if ((!((F->getName().find(*loopCond,0)))) ||
					   (!((F->getName().find(*whileCond,0)))) )
					{
						Loop * L = LI.getLoopFor(F);
						if(L)
						{
							unsigned loop_depth = LI.getLoopDepth(F);
							
							//errs()<<loop_depth<<"\n";
							//only deal with top level loops
							if(loop_depth==1)
							{
								loop_count++;
						
								//create a name for the loop
								std::string count1;
								ostringstream convert; 
								convert << loop_count; 
								count1 = func->getName();
								count1.append("_");
								count1.append(convert.str());
								
								//create shape for the loop
								std::string value24;
								value24 = count1;
								//create a label
							for(Loop::block_iterator BB = L->block_begin(), y = L->block_end(); 
								BB!= y; ++BB)
								{
									if(BB==L->block_begin())
									{
									BasicBlock* block=*BB;
									for (BasicBlock::iterator j = block->begin(), e = block->end(); j != e; ++j ) {	
									if(j==block->begin())	
																
								if (MDNode *N = j->getMetadata("dbg")) {  // Here I is an LLVM instruction
										DILocation Loc(N);                      // DILocation is in DebugInfo.h
									unsigned Line = Loc.getLineNumber();
									ostringstream convert2; 
									convert2 << Line; 
									StringRef File = Loc.getFilename();
									value24.append(" [label=\"");
									value24.append(count1);
									value24.append(" ");
									value24.append(File);
									value24.append(" line: ");
									value24.append(convert2.str());
									value24.append(" \",");
									break;
								}

							}
							
							}
							break;
							}
						
								
								value24.append(" color=\"bisque\", shape=\"rectangle\", style=\"filled\"];");
								value24.append("\n");
								myfile<<value24;
								
								//create 
								
								std::string value;
								value = func->getName();
								value.append(" -> ");
								value.append(count1);
								value.append(";\n");
						
								myfile<<value;
								//now all is left
								//1. If there is a function call inside loop body, treat the same way
								//   as when there is a function call inside function body
								//2. End the loop timer and start the function timer at the end of the
								//   loop
								for(Loop::block_iterator BB = L->block_begin(), y = L->block_end(); 
								BB!= y; ++BB)
								{
									BasicBlock* block=*BB;
									
									//remember block iterator also returns basic blocks of inner level loops
									//thus we need a depth check here too
									unsigned depth = LI.getLoopDepth(block);
									if(depth==1)
									{
										for (BasicBlock::iterator j = block->begin(), e = block->end(); j != e; ++j ) {

											if (CallInst* callInst = dyn_cast<CallInst>(&*j)) {
												Function* fun2 = dyn_cast<Function>(callInst->
													getCalledValue()->stripPointerCasts());

												if (fun2 != NULL) {
												size_t size1=9999;
												size_t size2=9999;
												size1 = fun2->getName().find(*timer_start,0);
												size2 = fun2->getName().find(*timer_end,0);

                            
												if ((size1<200) || (size2<200))
													continue;
												if(fun2->isIntrinsic())
												{
													//errs()<<"Intrinsic "<<fun3->getName()<<"\n";
													continue;
												}
												if(fun2->empty())
												{
													//errs()<<"Empty library "<<fun3->getName()<<"\n";
													continue;
												}
								std::string value12;
								value12 = count1;
								value12.append(" -> ");
								std::string name = fun2->getName();
								value12.append(name);
								value12.append(";\n");												
												myfile<<value12;
												}

												
											}//end of if a call instruction
										} //end of for loop
									}//end of if(depth==1)
								}//end of loop block iterator
								
							}//end of if (loop_depth==1)
						}//if(L) 

					}
				}
				
        }//end of Module iterator

			
            myfile.close();
            system("sort -u temp.dot > temp1.dot");
            //system("cat temp.dot > temp1.dot");
            system("rm -f temp.dot");
            system("echo \"digraph G { \" >> lcg.dot");
			system("cat temp1.dot>>lcg.dot");
            system("echo \"}\">>lcg.dot");
            system("rm -f temp1.dot");
            return true;
        }//end of runOnModule()
        
        virtual void getAnalysisUsage(AnalysisUsage &AU) const {
		AU.addRequired<LoopInfo>();
		AU.addPreserved<LoopInfo>();
            //AU.addRequiredID(BreakCriticalEdgesID);
            //AU.addRequiredID(LoopSimplifyID);
            //AU.addRequired<DominatorTree>();
        }
    };
}

char LCGraph::ID = 0;
static RegisterPass<LCGraph> X("lcgraph", "LCGraph generator",false);
