#define DEBUG_TYPE "ParaProf"
#include "llvm/Transforms/IPO.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Instructions.h"
#include "llvm/Module.h"
#include "llvm/ADT/StringRef.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Pass.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/InstIterator.h"
#include "llvm/Analysis/AliasAnalysis.h"
#include <fstream>
#include <set>
#include <stdlib.h>

#include "llvm/PassManager.h"

#include "llvm/Type.h"


#include "llvm/Analysis/LoopPass.h"


#include <list>

#include <cerrno>
#include <assert.h>
#include <iostream>
#include <sstream>
#include <string>
using namespace llvm;
using namespace std;

StringRef * timer_start= new StringRef ("timer_arnamoy_start");
StringRef * timer_end= new StringRef ("timer_arnamoy_end");
StringRef * print_kernels= new StringRef ("print_kernels_arnamoy");
StringRef * main= new StringRef ("main");
StringRef * loopCond= new StringRef ("for.cond");
StringRef * whileCond= new StringRef ("while.cond");
StringRef * loopInc= new StringRef ("for.inc");
StringRef * loopEnd= new StringRef ("for.end");
ValueToValueMapTy VMap;
ConstantInt* value_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
ConstantInt* value_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));

GlobalVariable* gvar_array__str;
GlobalVariable* gvar_ptr_s;
GlobalVariable* gvar_array__str_loop;
GlobalVariable* gvar_ptr_s_loop;
StoreInst* void_22;
LoadInst* ptr_23;

StoreInst* void_22_loop;
LoadInst* ptr_23_loop;

Constant *func_start;
Constant *func_end;

StoreInst* storeInst;

int loop_count;


namespace {
    struct ParaProf : public ModulePass {
        static char ID; // Pass identification, replacement for typeid
        unsigned NumLoops;
        ParaProf() : ModulePass(ID) {}
        
        virtual bool runOnModule(Module &M)
        {
			//here we have found the Value * we need to perfrom the alias analysis
			//now we have to find which functions and loops
			//have a may or must alias in their body for the found value
				
            
            
			for(Module::iterator func = M.begin(), y = M.end(); func!= y; ++func)
			{
				if(func->isDeclaration())
					continue;
				AliasAnalysis &AA = getAnalysis<AliasAnalysis>();
                LoopInfo &LI = getAnalysis<LoopInfo>(* func);
                
                
                //dealing with functions
                int found_in_function = 0;
				for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
	        	{
					//here a basic block may come that is part of a loop
					//don't deal with it as they are dealt separately later
					Loop *L = LI.getLoopFor(F);
					if(L) continue;
					std::ifstream input( "parameters.txt" );
					for( std::string line; getline( input, line ); )
					{
				
						//errs()<<"got here "<<line<<"\n";
						//for each input parameter
						//StoreInst* storeInst;
						//find the first store in the variable
						//because probably that is the first and ONLY
						//VAlue* of the paramemter you will find in the IR if
						//you search by "name"  coz everything is given
						//the name of a register in SSA
						int found_value = 0;
						AliasAnalysis::Location LocA;
						found_value = find_definition(M,line);
						if(found_value == 1)
						{
							found_value=0;
							LocA = AA.getLocation(storeInst);
							for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) {
							
								Instruction * instruction = j;	
								found_in_function = perform_aa(storeInst, AA,LocA,instruction,F,func->getName(),line);
								if(found_in_function == 1)
									break;
							}
						}	
					}//end of running through file to find paramemter
					if(found_in_function == 1)
						break;
				}//end of dealing with functions             
                        
               ////dealing with loops
               int found_in_loop = 0;
               for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
               {
					if ((!((F->getName().find(*loopCond,0)))) ||
					   (!((F->getName().find(*whileCond,0)))) )
					{
						Loop * L = LI.getLoopFor(F);
						if(L)
						{
							unsigned loop_depth = LI.getLoopDepth(F);
							
							//errs()<<loop_depth<<"\n";
							//only deal with top level loops
							if(loop_depth==1)
							{
								//errs()<<"Got candidate loop for "<<func->getName()<<"\n";
								loop_count++;
						
								//create a name for the loop
								std::string count1;
								ostringstream convert; 
								convert << loop_count; 
								count1 = func->getName();
								count1.append("_");
								count1.append(convert.str());
								
								//now find the store instruction
								std::ifstream input1( "parameters.txt" );   								
								for( std::string line; getline( input1, line ); )
								{
				
									//errs()<<"got here "<<line<<"\n";
									//for each input parameter
									//StoreInst* storeInst;
									//find the first store in the variable
									//because probably that is the first and ONLY
									//VAlue* of the paramemter you will find in the IR if
									//you search by "name"  coz everything is given
									//the name of a register in SSA
									int found_value = 0;
									AliasAnalysis::Location LocA;
									found_value = find_definition(M,line);
									
									//now lets see if the loop uses the value
									if(found_value == 1)
									{
										found_value=0;
										
										LocA = AA.getLocation(storeInst);
										for(Loop::block_iterator BB = L->block_begin(), y = L->block_end(); 
											BB!= y; ++BB)
										{
											BasicBlock* block=*BB;
											//errs()<<block->getName()<<"\n";
											
											for (BasicBlock::iterator j = block->begin(), e = block->end(); j != e; ++j ) {
												Instruction * instruction = j;
												found_in_loop = perform_aa(storeInst, AA,LocA,instruction,block,count1,line);
												if(found_in_loop == 1)
													break;
											}
											if(found_in_loop == 1)
													break;
										}
									}	
								}//end of going through file to search parameters
							}//end of if (loop_depth==1)
						}//end of if(L)
					}
				}//end of dealing with loops
			}//end of Module iterator
			ofstream myfile;
			myfile.open ("profile.txt",ios::app);
			std::string command;
			command = "====== \n";
			myfile<<command;
			myfile.close();
						
			return true;
	}//end of runOnModule()
    int write_to_profile_file(int interprocedural, AliasAnalysis::AliasResult result,std::string name, std::string param)
    {
		
		ofstream myfile;
		myfile.open ("profile.txt",ios::app);
		std::string command;
		command = name;
		command.append("::");
		command.append(param);
		command.append("\n");
		
		if(interprocedural == 1)
		{
			myfile<<command;
			myfile.close();
			return 1;
		}
		switch(result)
		{
			case 0://errs()<<  "NoAlias\n";
			return 0;
			///< No dependencies.
			case 1://errs()<<name<<"Uses "<<param<<"\n"; //may
			myfile<<command;
			myfile.close();
			return 1;
			case 2: //errs()<<name<<"Uses "<<param<<"\n"; //partial 
			myfile<<command;
			myfile.close();
			return 1;
			case 3: //errs()<<name<<"Uses "<<param<<"\n"; //must
			myfile<<command;
			myfile.close();
			return 1; 
		}
		
		return 0;
	}
	int perform_aa(StoreInst* storeInst2, AliasAnalysis &AA1, AliasAnalysis::Location LocA1, 
						Instruction * inst, BasicBlock * bb,std::string name,std::string param1)
	{
		if (StoreInst *storeInst1 = dyn_cast<StoreInst>(inst))
		{
			
			AliasAnalysis::Location loc=AA1.getLocation(storeInst1);
			AliasAnalysis::AliasResult ar;
			//errs()<<*storeInst1<<" "<<block->getName()<<"\n";
			//if(AA.pointsToConstantMemory(loc))
			//	errs()<<"Points to constant memory\n";
			//interprocedural alias analysis is not supported now
			//so only perform alias analysis if the variable is global
			//or variable is local to the function where the loop resides
											
			int perform_aa = 0;
			if(isa<GlobalVariable>(storeInst1->getOperand(1)))
				perform_aa = 1;
			Function *source = storeInst2->getParent()->getParent();
			Function * loop_func = bb->getParent();
			//errs()<<storeInst->getParent()->getParent()<< " "<<block->getParent()<<"\n";
			if(loop_func == source) perform_aa = 1;
			else
				//be conservative while interprocedural alias analysis
				return(write_to_profile_file(1,ar,name,param1));

			if(perform_aa == 1)
			{											
				perform_aa = 0;
				ar=AA1.alias(LocA1,loc);
				//errs()<<*storeInst1<<" "<<*storeInst<<" got here\n";
				return(write_to_profile_file(0,ar,name,param1));
			}
		}
		else if (LoadInst *loadInst1 = dyn_cast<LoadInst>(inst))
		{
			
			AliasAnalysis::Location loc=AA1.getLocation(loadInst1);
			AliasAnalysis::AliasResult ar;
														
			int perform_aa = 0;
			if(isa<GlobalVariable>(loadInst1->getOperand(0)))
				perform_aa = 1;
			Function *source = storeInst2->getParent()->getParent();
			Function * loop_func = bb->getParent();
			//errs()<<storeInst->getParent()->getParent()<< " "<<block->getParent()<<"\n";
			if(loop_func == source) perform_aa = 1;
			else
				//be conservative while interprocedural alias analysis
				return(write_to_profile_file(1,ar,name,param1));

			if(perform_aa == 1)
			{											
				perform_aa = 0;
				AliasAnalysis::AliasResult ar=AA1.alias(LocA1,loc);
				//errs()<<*storeInst1<<" "<<*storeInst<<" got here\n";
				return(write_to_profile_file(0,ar,name,param1));
			}
		}
		return 0;
	}  
	int find_definition(Module &M1,std::string line1){
		for(Module::iterator func1 = M1.begin(), y1 = M1.end(); func1!= y1; ++func1)
		{
			if (func1->isDeclaration())
				continue;
			for(Function::iterator F1 = func1->begin(), E1 = func1->end(); F1!= E1; ++F1)
			{
				for (BasicBlock::iterator j1 = F1->begin(), e1 = F1->end(); j1 != e1; ++j1 ) {
					if ((storeInst = dyn_cast<StoreInst>(&*j1))) {
						if(storeInst->getOperand(1)->getName().equals(line1))
						{
							//found the instruction
							//errs()<<"Found the sucker\n";
							//found_value = 1;
							return 1;
							
						}
					}
				}//end of basic block iterator
			}//end of function iterator
		}//end of Module iterator
		return 0;
	}  
	virtual void getAnalysisUsage(AnalysisUsage &AU) const {
		AU.addRequired<LoopInfo>();
		AU.addPreserved<LoopInfo>();
	    AU.addRequiredTransitive<AliasAnalysis>();
		AU.addPreserved<AliasAnalysis>();
            //AU.addRequiredID(BreakCriticalEdgesID);
            //AU.addRequiredID(LoopSimplifyID);
            //AU.addRequired<DominatorTree>();
    }
  };
}

char ParaProf::ID = 0;
static RegisterPass<ParaProf> X("paraprof", "Instrument for profiling the value of user supplied parammeters(inputs)",false);
