#define DEBUG_TYPE "ParaRec"
#include "llvm/Transforms/IPO.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Instructions.h"
#include "llvm/Module.h"
#include "llvm/ADT/StringRef.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Pass.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/InstIterator.h"
#include "llvm/Analysis/AliasAnalysis.h"
#include <fstream>
#include <set>

#include "llvm/PassManager.h"

#include "llvm/Type.h"


#include "llvm/Analysis/LoopPass.h"


#include <list>

#include <cerrno>
#include <assert.h>
#include <iostream>
#include <sstream>
#include <string>
using namespace llvm;
using namespace std;

StringRef * timer_start= new StringRef ("timer_arnamoy_start");
StringRef * timer_end= new StringRef ("timer_arnamoy_end");
StringRef * print_kernels= new StringRef ("print_kernels_arnamoy");
StringRef * main= new StringRef ("main");
StringRef * loopCond= new StringRef ("for.cond");
StringRef * whileCond= new StringRef ("while.cond");
StringRef * loopInc= new StringRef ("for.inc");
StringRef * loopEnd= new StringRef ("for.end");
ValueToValueMapTy VMap;
ConstantInt* value_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
ConstantInt* value_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));

GlobalVariable* gvar_array__str;
GlobalVariable* gvar_ptr_s;
GlobalVariable* gvar_array__str_loop;
GlobalVariable* gvar_ptr_s_loop;
StoreInst* void_22;
LoadInst* ptr_23;

Function *func_profile;

Constant *func_start;
Constant *func_end;

int loop_count;

Constant *profile_int;
Constant *profile_long;
Constant *profile_float;
Constant *profile_double;


namespace {
    struct ParaRec : public ModulePass {
        static char ID; // Pass identification, replacement for typeid
        unsigned NumLoops;
        ParaRec() : ModulePass(ID) {}
        
        virtual bool runOnModule(Module &M)
        {
			std::ifstream input( "parameters.txt" );
			PointerType * void_ty = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
			profile_int = M.getOrInsertFunction("profile_int", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  IntegerType::getInt32Ty(getGlobalContext()),
                                                  NULL);
			profile_float = M.getOrInsertFunction("profile_float", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  Type::getFloatTy(getGlobalContext()),
                                                  NULL);
			profile_long = M.getOrInsertFunction("profile_long", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  IntegerType::getInt64Ty(getGlobalContext()),
                                                  NULL);
			profile_double = M.getOrInsertFunction("profile_double", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  Type::getDoubleTy(getGlobalContext()),
                                                  NULL); 
            
			for( std::string line; getline( input, line ); )
			{
				
				//create a global string that contains the name of the variable
				         		//create a global string that has the function name as content
                    size_t size23 = line.size();
                    //errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
                    ArrayType* ArrayTy_0 = ArrayType::get(IntegerType::getInt8Ty(getGlobalContext()), size23+1);
                    PointerType* PointerTy_2 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
                                    
                    gvar_array__str = new GlobalVariable(/*Module=*/M,
                                                                        /*Type=*/ArrayTy_0,
                                                                        /*isConstant=*/true,
                                                                        /*Linkage=*/GlobalValue::PrivateLinkage,
                                                                        /*Initializer=*/0, // has initializer, specified below
                                                                        /*Name=*/".str");
                                   
                    gvar_ptr_s = new GlobalVariable(/*Module=*/M,
                                                                    /*Type=*/PointerTy_2,
                                                                    /*isConstant=*/false,
                                                                    /*Linkage=*/GlobalValue::CommonLinkage,
                                                                    /*Initializer=*/0, // has initializer, specified below
                                                                    /*Name=*/"s");
                                    
                    Constant* const_array_12 = ConstantDataArray::getString(getGlobalContext(),line , true);
                    ConstantPointerNull* const_ptr_13 = ConstantPointerNull::get(PointerTy_2);
                                    
                    ConstantInt* const_int32_16 = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
                    std::vector<Constant*> const_ptr_17_indices;
                    const_ptr_17_indices.push_back(const_int32_16);
                    const_ptr_17_indices.push_back(const_int32_16);
                    Constant* const_ptr_17 = ConstantExpr::getGetElementPtr(gvar_array__str, const_ptr_17_indices);
                                    
                    gvar_array__str->setInitializer(const_array_12);
                    gvar_ptr_s->setInitializer(const_ptr_13);
                                    

                    
                   
                    
				//errs()<<"got here "<<line<<"\n";
				//for each input parameter
				StoreInst* storeInst;
				//try to find the first store to the variable
				int found_value = 0;

				for(Module::iterator func1 = M.begin(), y1 = M.end(); func1!= y1; ++func1)
				{
					if (func1->isDeclaration())
						continue;
					for(Function::iterator F1 = func1->begin(), E1 = func1->end(); F1!= E1; ++F1)
					{
						for (BasicBlock::iterator j1 = F1->begin(), e1 = F1->end(); j1 != e1; ++j1 ) {
							 if (storeInst = dyn_cast<StoreInst>(&*j1)) {
								 if(storeInst->getOperand(1)->getName().equals(line))
								 {
								 
								 //found the instruction
								 //errs()<<"Found the sucker\n";
								 found_value = 1;
								 						//insert instrumentation code
								 						
				                  //store the function name in the new pointer created
                    void_22 = new StoreInst(const_ptr_17, gvar_ptr_s, false);
                    //get the value of the pointer so that we can pass it as an argument to replacement()
                   ptr_23 = new LoadInst(gvar_ptr_s, "", false);
						
						//get the type of the paramemter
						Type * ty = storeInst->getValueOperand()->getType();
						if(ty->isIntegerTy(32))
						{

               LoadInst* load = new LoadInst(storeInst->getPointerOperand(),"",false);
                                              
				std::vector<Value*> int32_15_params;
								
				int32_15_params.push_back(ptr_23);
				int32_15_params.push_back(load);
				 
				if(profile_int) 
					func_profile= cast<Function>(profile_int);
				
				CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
				load->insertAfter(storeInst);	
				void_22->insertAfter(load);
				ptr_23->insertAfter(void_22);
				call_print->insertAfter(ptr_23);		
				
				
			}
			else if(ty->isIntegerTy(64))
			//if((ty->isHalfTy())||(ty->isDoubleTy())||(ty->isFloatTy())
			//		||(ty->isIntegerTy(32))||(ty->isIntegerTy(64)))
			{
               LoadInst* load = new LoadInst(storeInst->getPointerOperand(),"",false);
                                              
				std::vector<Value*> int32_15_params;
								
				int32_15_params.push_back(ptr_23);
				int32_15_params.push_back(load);
				 
				if(profile_int) 
					func_profile= cast<Function>(profile_long);
				
				CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
				load->insertAfter(storeInst);	
				void_22->insertAfter(load);
				ptr_23->insertAfter(void_22);
				call_print->insertAfter(ptr_23);	
				
			}
			else if(ty->isFloatTy())
			//if((ty->isHalfTy())||(ty->isDoubleTy())||(ty->isFloatTy())
			//		||(ty->isIntegerTy(32))||(ty->isIntegerTy(64)))
			{
               LoadInst* load = new LoadInst(storeInst->getPointerOperand(),"",false);
                                              
				std::vector<Value*> int32_15_params;
								
				int32_15_params.push_back(ptr_23);
				int32_15_params.push_back(load);
				 
				if(profile_int) 
					func_profile= cast<Function>(profile_float);
				
				CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
				load->insertAfter(storeInst);	
				void_22->insertAfter(load);
				ptr_23->insertAfter(void_22);
				call_print->insertAfter(ptr_23);	
				
			}
			else if(ty->isDoubleTy())
			//if((ty->isHalfTy())||(ty->isDoubleTy())||(ty->isFloatTy())
			//		||(ty->isIntegerTy(32))||(ty->isIntegerTy(64)))
			{
               LoadInst* load = new LoadInst(storeInst->getPointerOperand(),"",false);
                                              
				std::vector<Value*> int32_15_params;
								
				int32_15_params.push_back(ptr_23);
				int32_15_params.push_back(load);
				 
				if(profile_int) 
					func_profile= cast<Function>(profile_double);
				
				CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
				load->insertAfter(storeInst);	
				void_22->insertAfter(load);
				ptr_23->insertAfter(void_22);
				call_print->insertAfter(ptr_23);	
				
			}
			
								 break;
								}
							 }
						}//end of basic block iterator
						if(found_value == 1)
							break;
						
					}//end of function iterator
					if(found_value == 1)
					{
						found_value = 0;
						break;
					}	
					}//end of Module iterator


					
			}
            return true;
        }//end of runOnModule()
        
        virtual void getAnalysisUsage(AnalysisUsage &AU) const {
		AU.addRequired<LoopInfo>();
		AU.addPreserved<LoopInfo>();
		    AU.addRequiredTransitive<AliasAnalysis>();
    AU.addPreserved<AliasAnalysis>();
            //AU.addRequiredID(BreakCriticalEdgesID);
            //AU.addRequiredID(LoopSimplifyID);
            //AU.addRequired<DominatorTree>();
        }
    };
}

char ParaRec::ID = 0;
static RegisterPass<ParaRec> X("pararec", "Instrument for profiling the value of user supplied parammeters(inputs)",false);
