#define DEBUG_TYPE "ValueInst"
#include "llvm/Transforms/IPO.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Instructions.h"
#include "llvm/Module.h"
#include "llvm/ADT/StringRef.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Pass.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/InstIterator.h"
#include <fstream>
#include <set>

#include "llvm/PassManager.h"

#include "llvm/Type.h"


#include "llvm/Analysis/LoopPass.h"


#include <list>

#include <cerrno>
#include <assert.h>
#include <iostream>
#include <sstream>
using namespace llvm;
using namespace std;

//our own library function names
StringRef * timer_start= new StringRef ("timer_arnamoy_start");
StringRef * timer_end= new StringRef ("timer_arnamoy_end");
StringRef * print_kernels= new StringRef ("print_kernels_arnamoy");
StringRef * profile_count= new StringRef ("profile_count");
StringRef * profile_int1= new StringRef ("profile_int");
StringRef * profile_long1= new StringRef ("profile_long");
StringRef * profile_float1= new StringRef ("profile_float");
StringRef * profile_double1= new StringRef ("profile_double");
StringRef * profile_single_pointer1= new StringRef ("profile_single_pointer");

StringRef * main= new StringRef ("main");
StringRef * loopCond= new StringRef ("for.cond");
StringRef * loopInc= new StringRef ("for.inc");
StringRef * loopEnd= new StringRef ("for.end");
StringRef * loopBody= new StringRef ("for.body");
ValueToValueMapTy VMap;
ConstantInt* value_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
ConstantInt* value_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));

PointerType* void_ty;
PointerType* int32_ty;
PointerType* int64_ty;
PointerType* float_ty;
PointerType* double_ty;


GlobalVariable* gvar_array__str;
GlobalVariable* gvar_ptr_s;
GlobalVariable* gvar_array__str_loop;
GlobalVariable* gvar_ptr_s_loop;
StoreInst* void_22;
LoadInst* ptr_23;

AllocaInst* ptr_s ;
AllocaInst* ptr_int32;
AllocaInst* ptr_int64;
AllocaInst* ptr_float;
AllocaInst* ptr_double;

StoreInst* void_22_loop;
LoadInst* ptr_23_loop;

Constant *profile_func;
Constant *profile_int;
Constant *profile_long;
Constant *profile_float;
Constant *profile_double;

Constant *profile_int_ptr;


Function *func_profile;
CallInst* call;
Loop * loop_a;

ConstantInt* const_one;
ConstantInt* const_zero;

long loop_count;
LoopInfo *LI;

namespace {
    struct ValueInst : public ModulePass {
        static char ID; // Pass identification, replacement for typeid
        unsigned NumLoops;
        ValueInst() : ModulePass(ID) {}
        
        virtual bool runOnModule(Module &M)
        {
			
			
			//two constant which hold values 0 and 1
			 const_one = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("1"), 10));
			 const_zero = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
			
			void_ty = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
			int32_ty = PointerType::get(IntegerType::getInt32Ty(getGlobalContext()), 0);
			int64_ty = PointerType::get(IntegerType::getInt64Ty(getGlobalContext()), 0);
			float_ty = PointerType::get(IntegerType::getFloatTy(getGlobalContext()), 0);
			double_ty = PointerType::get(IntegerType::getDoubleTy(getGlobalContext()), 0);
			
			profile_func = M.getOrInsertFunction("profile_count", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  IntegerType::getInt32Ty(getGlobalContext()),
                                                  NULL);
 			profile_int = M.getOrInsertFunction("profile_int", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  IntegerType::getInt32Ty(getGlobalContext()),
                                                  NULL);
			profile_float = M.getOrInsertFunction("profile_float", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  Type::getFloatTy(getGlobalContext()),
                                                  NULL);
			profile_long = M.getOrInsertFunction("profile_long", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  IntegerType::getInt64Ty(getGlobalContext()),
                                                  NULL);
			profile_double = M.getOrInsertFunction("profile_double", IntegerType::getInt32Ty
                                                  (getGlobalContext()), void_ty,
                                                  Type::getDoubleTy(getGlobalContext()),
                                                  NULL); 
			profile_int_ptr = M.getOrInsertFunction("profile_single_pointer", IntegerType::getInt32Ty
                                                  (getGlobalContext()), int32_ty,
                                                  Type::getDoubleTy(getGlobalContext()),
                                                  NULL);                                                                                                                                                                                                                                                        

            
			for(Module::iterator func = M.begin(), y = M.end(); func!= y; ++func)
        	{
                if (func->isDeclaration())
          			continue;
          			size_t size1=9999;
          		size_t size2=9999;
          		size_t size3=9999;
          		size_t size4=9999;
          		size_t size5=9999;
          		size_t size6=9999;
          		size_t size7=9999;
          		size_t size8=9999;
          		size_t size9=9999;
          		
                size1 = func->getName().find(*timer_start,0);
                size2 = func->getName().find(*timer_end,0);
                size3 = func->getName().find(*print_kernels,0);
				size4 = func->getName().find(*profile_count,0);
				size5 = func->getName().find(*profile_int1,0);
				size6 = func->getName().find(*profile_long1,0);
				size7 = func->getName().find(*profile_float1,0);
				size8 = func->getName().find(*profile_double1,0);
				size9 = func->getName().find(*profile_single_pointer1,0);
                            
                if ((size1<200) || (size2<200)||(size3<200)||(size4<200)
					||(size5<200) || (size6<200)||(size7<200)||(size8<200)
					||(size9<200))
                    continue;
          		//create a global string that has the function name as content
                    size_t size23 = func->getName().size();
                    //errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
                    ArrayType* ArrayTy_0 = ArrayType::get(IntegerType::getInt8Ty(getGlobalContext()), size23+1);
                    PointerType* PointerTy_2 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
                                    
                    gvar_array__str = new GlobalVariable(/*Module=*/M,
                                                                        /*Type=*/ArrayTy_0,
                                                                        /*isConstant=*/true,
                                                                        /*Linkage=*/GlobalValue::PrivateLinkage,
                                                                        /*Initializer=*/0, // has initializer, specified below
                                                                        /*Name=*/".str");
                                   
                    gvar_ptr_s = new GlobalVariable(/*Module=*/M,
                                                                    /*Type=*/PointerTy_2,
                                                                    /*isConstant=*/false,
                                                                    /*Linkage=*/GlobalValue::CommonLinkage,
                                                                    /*Initializer=*/0, // has initializer, specified below
                                                                    /*Name=*/"s");
                                    
                    Constant* const_array_12 = ConstantDataArray::getString(getGlobalContext(),func->getName() , true);
                    ConstantPointerNull* const_ptr_13 = ConstantPointerNull::get(PointerTy_2);
                                    
                    ConstantInt* const_int32_16 = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
                    std::vector<Constant*> const_ptr_17_indices;
                    const_ptr_17_indices.push_back(const_int32_16);
                    const_ptr_17_indices.push_back(const_int32_16);
                    Constant* const_ptr_17 = ConstantExpr::getGetElementPtr(gvar_array__str, const_ptr_17_indices);
                                    
                    gvar_array__str->setInitializer(const_array_12);
                    gvar_ptr_s->setInitializer(const_ptr_13);
                                    
                    //store the function name in the new pointer created
                    void_22 = new StoreInst(const_ptr_17, gvar_ptr_s, false);
                    //get the value of the pointer so that we can pass it as an argument to replacement()
                    ptr_23 = new LoadInst(gvar_ptr_s, "", false);
	
          		//allocate the pointer at the beginning of the module
				for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
                {
					if(F==func->begin())
					{
						for (BasicBlock::iterator j = F->begin(), e = F->end(); j != e; ++j ) {
							if(j==F->begin())
							{
								//create a void pointer to pass any variable used by function or loops
								
								ptr_s = new AllocaInst(void_ty, "void_ptr");
								ptr_int32 = new AllocaInst(int32_ty, "int32_ptr");
								ptr_int64 = new AllocaInst(int64_ty, "int64_ptr");
								ptr_float = new AllocaInst(float_ty, "float_ptr");
								ptr_double = new AllocaInst(double_ty, "double_ptr");
								
								F->getInstList().insert((Instruction*)j, ptr_s);
								F->getInstList().insert((Instruction*)j, ptr_int32);
								F->getInstList().insert((Instruction*)j, ptr_int64);
								F->getInstList().insert((Instruction*)j, ptr_float);
								F->getInstList().insert((Instruction*)j, ptr_double);
								F->getInstList().insert((Instruction*)j, void_22);
                                F->getInstList().insert((Instruction*)j, ptr_23);
							}
						}
					}
				}
				LI = &getAnalysis<LoopInfo>(*func);
          		
          		loop_count=0;
          		

				
                
               ////dealing with loops
               for(Function::iterator F = func->begin(), E = func->end(); F!= E; ++F)
               {
				   if(!((F->getName().find(*loopBody,0)))) continue;
				   if(!((F->getName().find(*loopInc,0)))) continue;
				   if(!((F->getName().find(*loopEnd,0)))) continue;
					if (!((F->getName().find(*loopCond,0))))
					{
						loop_a = LI->getLoopFor(F);
						if(loop_a)
						{
							unsigned loop_depth = LI->getLoopDepth(F);
							
							//errs()<<loop_depth<<"\n";
							//only deal with top level loops
							if(loop_depth==1)
							{
								Function * function = func;
								BasicBlock * block = F;
								//errs()<<block->getName()<<"\n";
								profileLoop(loop_a, function,block,M);
							}//end of if loop depth 1 
						}//end of if(loop)
					}//end of if basic block=for.cond*
					else
					{
						//BasicBlock *block1 = *F;
						errs()<<F->getName()<<" belongs to "<<func->getName()<<"\n";
						Function * function = func;
						BasicBlock * block = F;
						profileFunction(function,block,M);
					}
					
				}//end of function iterator 

            }//end of Module iterator
            
            return true;
        }//end of runOnModule()
        virtual bool isPointerToPointer(const Value* V) {
			const Type* T = V->getType();
			return T->isPointerTy() && T->getContainedType(0)->isPointerTy();
		}
		 bool profileLoop( const Loop * L,  Function * func,  BasicBlock * F, Module &M)
		{
			
			loop_count++;
			
			//LoopInfo *LI = &getAnalysis<LoopInfo>(* func);			
			//create a name for the loop
			std::string count1;
			ostringstream convert; 
			convert << loop_count; 
			count1 = func->getName();
			count1.append("_");
			count1.append(convert.str());
								
			//and create a global variable with the string name
			size_t size23 = count1.size();
			//errs() <<CI -> getCalledFunction()->getName()<< " String size is "<<size23<< "\n";
                                    
			ArrayType* ArrayTy_0 = ArrayType::get(IntegerType::getInt8Ty(getGlobalContext()), size23+1);
			PointerType* PointerTy_2 = PointerType::get(IntegerType::getInt8Ty(getGlobalContext()), 0);
             
             
                                    
			gvar_array__str_loop = new GlobalVariable(M,
                                       ArrayTy_0,
                                       true,
                                      GlobalValue::PrivateLinkage,
                                      0, // has initializer, specified below
                                      ".str");
                                   
			gvar_ptr_s_loop = new GlobalVariable(M,
                                            PointerTy_2,
                                          false,
                                         GlobalValue::CommonLinkage,
                                       0, // has initializer, specified below
                                        "s");
                                 
			Constant* const_array_12 = ConstantDataArray::getString(getGlobalContext(),count1 , true);
			ConstantPointerNull* const_ptr_13 = ConstantPointerNull::get(PointerTy_2);
                                    
			ConstantInt* const_int32_16 = ConstantInt::get(getGlobalContext(), 
											APInt(32, StringRef("0"), 10));
			std::vector<Constant*> const_ptr_17_indices;
			const_ptr_17_indices.push_back(const_int32_16);
			const_ptr_17_indices.push_back(const_int32_16);
			Constant* const_ptr_17 = ConstantExpr::getGetElementPtr(gvar_array__str_loop,
									const_ptr_17_indices);
                                    
			gvar_array__str_loop->setInitializer(const_array_12);
			gvar_ptr_s_loop->setInitializer(const_ptr_13);
            
                                    
			//store the loop name in the new pointer created
			void_22_loop = new StoreInst(const_ptr_17, gvar_ptr_s_loop, false);
			//get the value of the pointer so that 
			//we can pass it as an argument to replacement()
			ptr_23_loop = new LoadInst(gvar_ptr_s_loop, "", false);
								
			//now insert the load and store instructions 
			//just before entry to the loop

			for (pred_iterator I = pred_begin(F), E = pred_end(F); I != E; ++I)  
			{   
				BasicBlock *Pred = *I;
				if (!((Pred->getName().find(*loopInc,0))))
					continue;
				else
				{
					//insert the load and store instructions
					void_22_loop->insertBefore(Pred->getTerminator());
					ptr_23_loop->insertBefore(Pred->getTerminator());
				}
						
			}
			 
			//now check which variables used inside loops 
			//come from outside of the loop
			//and profile them,there are some special treatments here
			// 1. Don't profile anything in for.cond (both for outer and inner loops) 
			//    other than the loop upper count.
			//    because we don't want to profile the value of loop induction variable
			//    for each iteration of the loop
			// 2. For the outermost loop, we only look for variables 
			//    inside the for.body
			//    of the outer loop, for.body of inner loop(s) and for.end of inner loop(s)
			// 3. The increment in for.inc gives information about 
			//    the induction variable 
								
			ConstantInt* icount = ConstantInt::get(getGlobalContext(), APInt(32, StringRef("0"), 10));
			Value *IterationCount = new GlobalVariable(M,
                      	                IntegerType::get(getGlobalContext(), 32),
       		        	                false,
       		        	                GlobalValue::ExternalLinkage,
       		        	                icount,
       		        	                "iterationCount");
       		
       		      	                
			for(Loop::block_iterator BB = L->block_begin(), y = L->block_end(); BB!= y; ++BB)
			{
				 
				 BasicBlock* block=*BB;
				if(BasicBlock* block=*BB)
				{ 
				
					
				if (!((block->getName().find(*loopCond,0))))
				{
					
					Loop * L1 = LI->getLoopFor(block);
					
					if(L1!=L)
					{
						
					    //we got an inner loop
					    //create a variable for iteration count
						Value *IterationCount1 = new GlobalVariable(M,
	                    	                IntegerType::get(getGlobalContext(), 32),
	                    	                false,
	                    	                GlobalValue::ExternalLinkage,
	                    	                icount,
	                    	                "iterationCountInner");
	                    //now two things
	                    // 1. Increase iteration count by 1 inside loop body
	               		// 2. Reset iteration count at the end of the loop
	               		// 3.  Insert a call to profile iteration count at the 
	               		// 4.  end of the loop
	               		//it's a candidate loop
	               		for(Loop::block_iterator BB1 = L1->block_begin(), y1 = L1->block_end(); 
								BB1!= y1; ++BB1)
						{
							BasicBlock * block1 = *BB1;
							if (!(block1->getName().find(*loopBody,0)))
							{
								LoadInst* int32_16 = new LoadInst
											(IterationCount1, "", false);
								BinaryOperator* int32_17 = BinaryOperator::Create(Instruction::Add, int32_16,
													 			const_one, "");
								StoreInst* void_18 = new StoreInst(int32_17, 
												IterationCount1, false);
				
								for (BasicBlock::iterator j1 = block1->begin(), 
									e1 = block1->end(); j1 != e1; ++j1 ) {

									//if first instruction of loop body, 
									//add the following instructions
									//load count;
									//inc count;
									//store count
									if(j1 == block1->begin())
									{
							
										block1->getInstList().insert(j1, int32_16);
										block1->getInstList().insert(j1, int32_17);
										block1->getInstList().insert(j1, void_18);
										break;
									}//end of if
								}
							}//end of if loop body
						}//end of iterating over blocks of inner loop
											
						//find the loop exit block
						//and add instructions to clear iteration count
						//and call profiling
						BasicBlock * last1 = L1->getUniqueExitBlock();
						for (BasicBlock::iterator j1 = last1->begin(), 
								e1 = last1->end(); j1 != e1; ++j1 ) {
							if(j1 == last1->begin())
							{
								LoadInst* load_count = new LoadInst(IterationCount1,"", false);
								std::vector<Value*> int32_15_params;
								
								int32_15_params.push_back(ptr_23_loop);
								int32_15_params.push_back(load_count);
								            if(profile_func) 
            {
				errs()<<"got function\n";
				func_profile= cast<Function>(profile_func);
			}
								CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
								StoreInst* void_18 = new StoreInst(const_zero, 
												IterationCount1, false);
														
								last1->getInstList().insert(j1, load_count);
								last1->getInstList().insert(j1, call_print);
								last1->getInstList().insert(j1, void_18);
								break;
							}//end of if
						}
					}//end of if inner loop
				}//end of if (block_name==for.cond*)

				else if (!((block->getName().find(*loopBody,0))))
				{
					Loop * L1 = LI->getLoopFor(block);
					if(L1==L)
					{
						//we got the body of outer most loop
						//here also increment the iterationCount
						LoadInst* int32_16 = new LoadInst(IterationCount, "", false);
						BinaryOperator* int32_17 = BinaryOperator::Create(Instruction::Add, 
														int32_16, const_one, "");
						StoreInst* void_18 = new StoreInst(int32_17, IterationCount, false);
				
						for (BasicBlock::iterator j1 = block->begin(), 
								e1 = block->end(); j1 != e1; ++j1 ) {

							//if first instruction of loop body, 
							//add the following instructions
							//load count;
							//inc count;
							//store count
							if(j1 == block->begin())
							{
								block->getInstList().insert(j1, int32_16);
								block->getInstList().insert(j1, int32_17);
								block->getInstList().insert(j1, void_18);
								break;
							}//end of if
						}
					}//end of if outer loop
				}//end of if(block_name == for.body*)
			}
				//errs()<<block->getName()<<" belongs to "<<count1<<"\n";
			}//end of loop block iterator
			
			
			BasicBlock *last=loop_a->getUniqueExitBlock();

			//errs()<<last->getName()<<" belongs to "<<func->getName()<<"\n";
			
			
			//here clear the iteration count of the outer loop
			//and insert call to profiling function
			for (BasicBlock::iterator j1 = last->begin(), 
						e1 = last->end(); j1 != e1; ++j1 ) {
				if(j1 == last->begin())
				{
					LoadInst* load_count = new LoadInst(IterationCount,"", false);
					std::vector<Value*> int32_15_params;
					int32_15_params.push_back(ptr_23_loop);
					int32_15_params.push_back(load_count);
					            if(profile_func) 
            {
				errs()<<"got function\n";
				func_profile= cast<Function>(profile_func);
			}
					CallInst* call_print = CallInst::Create(func_profile, 
									int32_15_params, "");
					StoreInst* void_18 = new StoreInst(const_zero, 
									IterationCount, false);
														
					last->getInstList().insert(j1, load_count);
					last->getInstList().insert(j1, call_print);
					last->getInstList().insert(j1, void_18);
					break;
				}//end of if
			}
			return true;
		}//end of function profileLoop
		bool profileFunction( Function * func,  BasicBlock * block, Module &M)
		{
//			errs()<<"for basic block "<<block->getName()<<"\n";
			for (BasicBlock::iterator j = block->begin(), 
			e = block->end(); j != e; ++j ) {
										
										//we don't care about branches
										if (BranchInst* brInst = dyn_cast<BranchInst>(&*j))
												continue;
										//we don't care about GetElementPtr
										if (GetElementPtrInst* GEPInst = dyn_cast<GetElementPtrInst>(&*j))
												continue;
										//we don't care about allocas
										if (AllocaInst* alloca_inst = dyn_cast<AllocaInst>(&*j))
												continue;
										
										
										for (User::op_iterator i = j->op_begin(), 
										e = j->op_end(); i != e; ++i) {
											

											Value *v = *i;

											
											if (Constant* CI = dyn_cast<Constant>(v))
											{
												//we don't have to profile
												//if the value is constant
												//for all executions
												continue;
												//errs()<<"Instruction "<<*j<<"\n";
												//errs()<<"Value "<<*v<<"\n";
											}
											else
											{
												//here the value is not constant
												//check whether the value comes from outside
												//of the loop
												Instruction * inst1 = dyn_cast<Instruction>(v);
												
												
												BasicBlock * bb;
												if(inst1)
												{
													bb=inst1->getParent();
												//errs()<<"Here 3\n";
													if(bb)
													{
														Function * fn = bb->getParent();
												
													//Loop * loop1 = LI.getLoopFor(bb);
														if(fn != func)
														{
															//errs()<<"Value "<<*v<<"\n Comes from outside \n";
													
															//here we need to profile the value
															Instruction *ins = j;
															insertProfileCall(v,ins,block);
													
															//we have a void pointer that can take the address of the value
															//and pass it to our profiling function
													
															//case 1: The value is a normal variable (int/float/double)
													
													
														}
														//else
															//errs()<<"Value "<<*v<<"\n Comes from inside \n";
														}//end of if(bb)
												}
												else
												{
													//we din't find an instruction for the value 
													// that also means we have to profile
													//it can happen for argc, argv and external variables
													//errs()<<"Value "<<*v<<"\n Comes from inside \n";
													Instruction *ins = j;
													insertProfileCall(v,ins,block);
												}
											}
 
										}
									}
		}
		bool insertProfileCall(Value *v, Instruction * instruction, BasicBlock * bblock)
		{
			Type * ty = v->getType();
			if(ty->isIntegerTy(32))
			//if((ty->isHalfTy())||(ty->isDoubleTy())||(ty->isFloatTy())
			//		||(ty->isIntegerTy(32))||(ty->isIntegerTy(64)))
			{
				errs()<<"Got one ha ha\n";
				AllocaInst * alloca1 = new AllocaInst(IntegerType::getInt32Ty
                                                  (getGlobalContext()), "int_arnie");
				
                StoreInst* store = new StoreInst(v, alloca1,false); 
                LoadInst* load = new LoadInst(alloca1,"",false);
                                              
				std::vector<Value*> int32_15_params;
								
				int32_15_params.push_back(ptr_23);
				int32_15_params.push_back(load);
				 
				if(profile_int) 
					func_profile= cast<Function>(profile_int);
				
				CallInst* call_print = CallInst::Create(func_profile, 
											int32_15_params, "");
				
				bblock->getInstList().insert(instruction, alloca1);
				
				bblock->getInstList().insert(instruction, store);
				bblock->getInstList().insert(instruction, load);				
				bblock->getInstList().insert(instruction, call_print);
				return true;
			}
			return false;
		}
        virtual void getAnalysisUsage(AnalysisUsage &AU) const {
		AU.addRequired<LoopInfo>();
		AU.addPreserved<LoopInfo>();
            //AU.addRequiredID(BreakCriticalEdgesID);
            //AU.addRequiredID(LoopSimplifyID);
            //AU.addRequired<DominatorTree>();
        }
        
    };
}

char ValueInst::ID = 0;
static RegisterPass<ValueInst> X("value-inst", "ValueInst the supplied function",false);

									/*for (BasicBlock::iterator j = block->begin(), 
									e = block->end(); j != e; ++j ) {
										
										//we don't care about branches
										if (BranchInst* brInst = dyn_cast<BranchInst>(&*j))
												continue;
										//we don't care about GetElementPtr
										if (GetElementPtrInst* GEPInst = dyn_cast<GetElementPtrInst>(&*j))
												continue;
										//errs()<<"Instruction "<<*j<<"\n";
										for (User::op_iterator i = j->op_begin(), 
										e = j->op_end(); i != e; ++i) {
											Value *v = *i;
											
											if (Constant* CI = dyn_cast<Constant>(v))
											{
												//we don't have to profile
												//if the value is constant
												//for all executions
												continue;
												//errs()<<"Instruction "<<*j<<"\n";
												//errs()<<"Value "<<*v<<"\n";
											}
											else
											{
												//here the value is not constant
												//check whether the value comes from outside
												//of the loop
												Instruction * inst1 = dyn_cast<Instruction>(v);
												BasicBlock * bb = inst1->getParent();
												Loop * loop1 = LI.getLoopFor(bb);
												if(loop1 != L)
												{
													errs()<<"Value "<<*v<<"\n Comes from outside \n";
													//here we need to profile the value
													
												}
												else
													errs()<<"Value "<<*v<<"\n Comes from inside \n";
											}
 
										}
									}*/
